﻿package away3d.primitives{
	
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.extrusions.*;
	import away3d.materials.*;
	
	public class Trident {
	
		public function Trident(scene:Scene3D, len:Number = 1000){
			init(scene, len);
		}
		
		private function init(scene:Scene3D, len:Number):void
		{
			
			var scaleH:Number = len/10;
			var scaleW:Number = len/20;
			var offset:Number = len+scaleW;
			
			var matx:WireframeMaterial = new WireframeMaterial( 0xFF0000, {width:0});
			var maty:WireframeMaterial = new WireframeMaterial( 0x00FF00, {width:0});
			var matz:WireframeMaterial = new WireframeMaterial( 0x0000FF, {width:0});
			var lineX:LineSegment = new LineSegment({material:matx});
			var lineY:LineSegment = new LineSegment({material:maty});
			var lineZ:LineSegment = new LineSegment({material:matz});
			
			var pijlx:Lathe = new Lathe([new Number3D(0,0,0), new Number3D(-scaleW,0,0), new Number3D(0,scaleH,0)], {recenter:true, subdivision:4, material:matx});
			pijlx.rotationZ = -90;
			pijlx.z = 0;
			pijlx.x = offset;
			pijlx.y = 0;
			
			var pijly:Lathe = new Lathe([new Number3D(0,0,0), new Number3D(-scaleW,0,0), new Number3D(0,scaleH,0)], {recenter:true, subdivision:4, material:maty});
			pijly.y = offset;
			
			var pijlz:Lathe = new Lathe([new Number3D(0,0,0), new Number3D(-scaleW,0,0), new Number3D(0,scaleH,0)], {recenter:true, subdivision:4, material:matz});
			pijlz.rotationX = -90;
			pijlz.z = offset;
			pijlz.x = 0;
			pijlz.y = 0;
			scene.addChild(pijlx);
			scene.addChild(pijly);
			scene.addChild(pijlz);
			//x
			lineX.start = new Vertex(0,0,0);
			lineX.end = new Vertex(len,0,0);
			scene.addChild(lineX);
			//y
			lineY.start = new Vertex(0,0,0);
			lineY.end = new Vertex(0,len,0);
			scene.addChild(lineY);
			//z
			lineZ.start = new Vertex(0,0,0);
			lineZ.end = new Vertex(0,0,len);
			scene.addChild(lineZ);		
		}
		
	}
}