﻿package away3d.sprites
{
    import away3d.core.*;
    import away3d.core.base.*
    import away3d.core.base.*;
    import away3d.core.render.*;
    import away3d.core.draw.*;
    import away3d.materials.*;
    import away3d.core.math.*;
    import away3d.core.utils.*;

    import flash.display.DisplayObject;

    public class MovieClipSprite extends Object3D implements IPrimitiveProvider
    {
        private var center:Vertex = new Vertex();

        public var movieclip:DisplayObject;
        public var scaling:Number;
        public var deltaZ:Number;
		public var rescale:Boolean;

        public function MovieClipSprite(movieclip:DisplayObject, init:Object = null)
        {
            super(init);

            this.movieclip = movieclip;

            init = Init.parse(init);

            scaling = init.getNumber("scaling", 1);
            deltaZ = init.getNumber("deltaZ", 0);
			rescale = init.getBoolean("rescale", false);
        }
    
        override public function primitives(consumer:IPrimitiveConsumer, session:AbstractRenderSession):void
        {
        	super.primitives(consumer, session);
        	
            use namespace arcane;

            var sc:ScreenVertex = center.project(projection);
            var persp:Number = projection.zoom / (1 + sc.z / projection.focus);
            sc.z += deltaZ;
            sc.x -= movieclip.width/2;
            sc.y -= movieclip.height/2;
			 
			if(rescale ) movieclip.scaleX = movieclip.scaleY = persp*scaling;
			 
			
            consumer.primitive(new DrawDisplayObject(this, movieclip, sc, session));
        }
    }
}
